VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPreview"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const API_TRUE As Long = &H1&
Private Const MAX_PATH As Long = 260&
Private Const CC_STDCALL As Long = &H4&
Private Const IID_Release As Long = &H8&
Private Const FLOODFILLSURFACE As Long = &H1&
Private Const CLSCTX_LOCAL_SERVER As Long = &H4&
Private Const CLSCTX_INPROC_SERVER As Long = &H11

Private Const IID_IPicture As String = "{7bf80980-bf32-101a-8bbb-00aa00300cab}"
Private Const IID_IShellItem As String = "{43826d1e-e718-42ee-bc55-a1e261c37bfe}"
Private Const IID_IShellFolder As String = "{000214e6-0000-0000-c000-000000000046}"
Private Const IID_IShellItemImageFactory As String = "{bcc18b79-ba16-442f-80c4-8a59c30c463b}"

Private Const IID_IExtractImage As String = "{bb2e617c-0920-11d1-9a0b-00c04fc2d6c1}"
Private Const IID_IPreviewHandler As String = "{8895b1c6-b41f-4c1c-a562-0d564250836f}"
Private Const IID_IThumbnailProvider As String = "{e357fccd-a995-4576-b01f-234630154e96}"

Private Const IID_IPreviewHandlerFrame As String = "{fec87aaf-35f9-447a-adb7-20234491401a}"
Private Const IID_IPreviewHandlerVisuals As String = "{196bf9a5-b346-4ef0-aa1e-5dcdb76768b1}"

Private Const IID_IInitializeWithFile As String = "{b7d14566-0509-4cce-a71f-0a554233bd9b}"
Private Const IID_IInitializeWithItem As String = "{7f73be3f-fb79-493c-a6c7-7ee14e245841}"
Private Const IID_IInitializeWithStream As String = "{b824b49d-22ac-4161-ac8a-9916e8fa3f7f}"

' ----==== Enum ====----
Private Enum vtb_Interfaces
    
    ' IUnknown
    QueryInterface = 0

    ' IPreviewHandler
    SetWindow = 3
    SetRect = 4
    DoPreview = 5
    Unload = 6
    SetFocus = 7
    QueryFocus = 8
    TranslateAccelerator_IPH = 9

    ' IInitializeWithFile / IInitializeWithStream / IInitializeWithItem
    Initialize = 3
    
    ' IPreviewHandlerVisuals
    SetBackgroundColor = 3
    SetFont = 4
    SetTextColor = 5

    ' IPreviewHandlerFrame
    GetWindowContext = 3
    TranslateAccelerator_IPHF = 4

    ' IThumbnailProvider
    GetThumbnail = 3
    
    ' IExtractImage
    GetLocation = 3
    Extract = 4
    
    ' IShellFolder
    BindToObject = 5
    ParseDisplayName = 3
    GetUIObjectOf = 10
    
    ' IShellItemImageFactory
    GetImage = 3
    
End Enum

Private Enum ASSOCF
    ASSOCF_NONE = &H0&
    ASSOCF_INIT_NOREMAPCLSID = &H1&
    ASSOCF_INIT_BYEXENAME = &H2&
    ASSOCF_OPEN_BYEXENAME = &H2&
    ASSOCF_INIT_DEFAULTTOSTAR = &H4&
    ASSOCF_INIT_DEFAULTTOFOLDER = &H8&
    ASSOCF_NOUSERSETTINGS = &H10&
    ASSOCF_NOTRUNCATE = &H20&
    ASSOCF_VERIFY = &H40&
    ASSOCF_REMAPRUNDLL = &H80&
    ASSOCF_NOFIXUPS = &H100&
    ASSOCF_IGNOREBASECLASS = &H200&
    ASSOCF_INIT_IGNOREUNKNOWN = &H400&
    ASSOCF_INIT_FIXED_PROGID = &H800&
    ASSOCF_IS_PROTOCOL = &H1000&
    ASSOCF_INIT_FOR_FILE = &H2000&
End Enum

Private Enum ASSOCSTR
    ASSOCSTR_COMMAND = &H1&
    ASSOCSTR_EXECUTABLE = &H2&
    ASSOCSTR_FRIENDLYDOCNAME = &H3&
    ASSOCSTR_FRIENDLYAPPNAME = &H4&
    ASSOCSTR_NOOPEN = &H5&
    ASSOCSTR_SHELLNEWVALUE = &H6&
    ASSOCSTR_DDECOMMAND = &H7&
    ASSOCSTR_DDEIFEXEC = &H8&
    ASSOCSTR_DDEAPPLICATION = &H9&
    ASSOCSTR_DDETOPIC = &HA&
    ASSOCSTR_INFOTIP = &HB&
    ASSOCSTR_QUICKTIP = &HC&
    ASSOCSTR_TILEINFO = &HD&
    ASSOCSTR_CONTENTTYPE = &HE&
    ASSOCSTR_DEFAULTICON = &HF&
    ASSOCSTR_SHELLEXTENSION = &H10&
    ASSOCSTR_DROPTARGET = &H11&
    ASSOCSTR_DELEGATEEXECUTE = &H12&
    ASSOCSTR_SUPPORTED_URI_PROTOCOLS = &H13&
    ASSOCSTR_PROGID = &H14&
    ASSOCSTR_APPID = &H15&
    ASSOCSTR_APPPUBLISHER = &H16&
    ASSOCSTR_APPICONREFERENCE = &H17&
    ASSOCSTR_MAX = &H18&
End Enum

Public Enum STGM
    STGM_FAILIFTHERE = &H0
    STGM_DIRECT = &H0
    STGM_READ = &H0
    STGM_WRITE = &H1
    STGM_READWRITE = &H2
    STGM_SHARE_EXCLUSIVE = &H10
    STGM_SHARE_DENY_WRITE = &H20
    STGM_SHARE_DENY_READ = &H30
    STGM_SHARE_DENY_NONE = &H40
    STGM_CREATE = &H1000
    STGM_TRANSACTED = &H10000
    STGM_CONVERT = &H20000
    STGM_PRIORITY = &H40000
    STGM_NOSCRATCH = &H100000
    STGM_NOSNAPSHOT = &H200000
    STGM_DIRECT_SWMR = &H400000
    STGM_SIMPLE = &H8000000
    STGM_DELETEONRELEASE = &H4000000
End Enum

Private Enum WTS_ALPHATYPE
    WTSAT_UNKNOWN = &H0&
    WTSAT_RGB = &H1&
    WTSAT_ARGB = &H2&
End Enum

Private Enum IEI_FLAGS
    IEI_PRIORITY_NORMAL = &H0&
    IEI_PRIORITY_MIN = &H1&
    IEI_PRIORITY_MAX = &H2&
End Enum

Private Enum IEIFLAG_FLAGS
    IEIFLAG_OFFLINE = &H8&
    IEIFLAG_SCREEN = &H20&
    IEIFLAG_ORIGSIZE = &H40&
    IEIFLAG_QUALITY = &H200&
    IEIFLAG_REFRESH = &H400&
End Enum

Public Enum SIIGBF
    SIIGBF_RESIZETOFIT = &H0&
    SIIGBF_BIGGERSIZEOK = &H1&
    SIIGBF_MEMORYONLY = &H2&
    SIIGBF_ICONONLY = &H4&
    SIIGBF_THUMBNAILONLY = &H8&
    SIIGBF_INCACHEONLY = &H10&
    SIIGBF_CROPTOSQUARE = &H20&
    SIIGBF_WIDETHUMBNAILS = &H40&
    SIIGBF_ICONBACKGROUND = &H80&
    SIIGBF_SCALEUP = &H100&
End Enum

' ----==== Type ====----
Private Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Private Type SIZE
    cx As Long
    cy As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type PICTDESC
    cbSizeOfStruct As Long
    picType As Long
    hgdiObj As Long
    hPalOrXYExt As Long
End Type

' ----==== Gdi32.dll Deklarationen ====----
Private Declare Function SelectObject Lib "Gdi32.dll" ( _
                         ByVal hdc As Long, _
                         ByVal hObject As Long) As Long
                         
Private Declare Function CreateSolidBrush Lib "Gdi32.dll" ( _
                         ByVal crColor As Long) As Long
                         
Private Declare Function DeleteObject Lib "Gdi32.dll" ( _
                         ByVal hObject As Long) As Long
                         
Private Declare Function ExtFloodFill Lib "Gdi32.dll" ( _
                         ByVal hdc As Long, _
                         ByVal x As Long, _
                         ByVal y As Long, _
                         ByVal crColor As Long, _
                         ByVal wFillType As Long) As Long
                         
' ----==== Shlwapi.dll Deklarationen ====----
Private Declare Function AssocQueryStringW Lib "shlwapi.dll" ( _
                         ByVal flags As ASSOCF, _
                         ByVal str As ASSOCSTR, _
                         ByVal pszAssoc As Long, _
                         ByVal pszExtra As Long, _
                         ByVal pszOut As Long, _
                         ByRef pcchOut As Long) As Long

Private Declare Function SHCreateStreamOnFileEx Lib "shlwapi.dll" ( _
                         ByVal pszFile As Long, _
                         ByVal grfMode As STGM, _
                         ByVal dwAttributes As Long, _
                         ByVal fCreate As Long, _
                         ByVal pstmTemplate As Long, _
                         ByRef ppstm As Long) As Long

' ----==== Shell32.dll Deklarationen ====----
Private Declare Function SHCreateItemFromParsingName Lib "Shell32.dll" ( _
                         ByVal pszPath As Long, _
                         ByVal pbc As Long, _
                         ByVal riid As Long, _
                         ByRef pUnk As Long) As Long

Private Declare Function SHParseDisplayName Lib "Shell32.dll" ( _
                         ByVal pszPath As Long, _
                         ByVal pbc As Long, _
                         ByRef ppidl As Long, _
                         ByVal sfgaoIn As Long, _
                         ByRef sfgaoOut As Long) As Long

Private Declare Function SHGetDesktopFolder Lib "Shell32.dll" ( _
                         ByRef ppshf As Long) As Long

' ----==== Ole32.dll Deklarationen ====----
Private Declare Sub CoTaskMemFree Lib "Ole32.dll" ( _
                    ByVal hMem As Long)

Private Declare Function CoCreateInstance Lib "Ole32.dll" ( _
                         ByVal rclsid As Long, _
                         ByVal pUnkOuter As Long, _
                         ByVal dwClsContext As Long, _
                         ByVal riid As Long, _
                         ByRef ppv As Long) As Long

Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pString As Long, _
                         ByRef pCLSID As GUID) As Long

' ----==== Oleaut32.dll Deklarationen ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long

Private Declare Function OleCreatePictureIndirect Lib "Oleaut32.dll" ( _
                         ByRef lpPictDesc As PICTDESC, _
                         ByRef riid As GUID, _
                         ByVal fOwn As Long, _
                         ByRef lplpvObj As Object) As Long

' ----==== Variablen ====----
Private m_pLOGFONTW As Long
Private m_lngBackColor As Long
Private m_lngTextColor As Long
Private m_bolDebug  As Boolean
Private m_strFileName As String
Private m_oPicture As StdPicture
Private m_pIPreviewHandler As Long
Private m_oPreviewWindow As PictureBox

Private Sub Class_Terminate()
    
    ' alles lschen, zurck setzen und freigeben
    UnloadAndRelease
    
End Sub

' ----==== Erstellt eine Vorschau von einer Datei / Ordner ====----
Public Function ShowPreviewForFile(ByVal strFileName As String, _
    ByVal oPreviewWindow As PictureBox, _
    ByVal lngLeft As Long, ByVal lngTop As Long, _
    ByVal lngWidth As Long, ByVal lngHeight As Long, _
    Optional ByVal lngBackColor As Long = vbWhite, _
    Optional ByVal lngTextColor As Long = vbBlack, _
    Optional ByVal pLOGFONTW As Long = 0&, _
    Optional ByVal bolDebug As Boolean = False) As Boolean

    Dim bolRet As Boolean
    Dim hBitmap As Long
    Dim lngThumbSize As Long
    Dim pIDL(0) As Long
    Dim pIShellFolder As Long
    Dim pIExtractImage As Long
    Dim pIShellFolder_Item As Long
    Dim pIThumbnailProvider As Long
    Dim pIPreviewHandlerFrame As Long
    Dim pIPreviewHandlerVisuals As Long
    Dim pIShellItemImageFactory As Long
    Dim strImage As String
    Dim strCLSID_Handler As String
    Dim tRECT As RECT
    Dim tSIZE As SIZE
    Dim ePriority As IEI_FLAGS
    Dim eFlags As IEIFLAG_FLAGS
    
    bolRet = False
    
    ' alles lschen, zurck setzen und freigeben
    UnloadAndRelease
    
    ' diverses speichern
    m_strFileName = strFileName
    m_bolDebug = bolDebug
    m_pLOGFONTW = pLOGFONTW
    m_lngBackColor = lngBackColor
    m_lngTextColor = lngTextColor
    Set m_oPreviewWindow = oPreviewWindow
    
    ' PreviewHandler fr IPreviewHandler ermitteln
    If GetHandlerClsidFromFile(strFileName, IID_IPreviewHandler, _
        strCLSID_Handler) = True Then
    
        If m_bolDebug = True Then Debug.Print "PreviewHandlerClsid ber IID_IPreviewHandler und CLSID = " & strCLSID_Handler
    
        ' erstellt ein IPreviewHandler aus der CLSID des PreviewHandler und IID_IPreviewHandler
        If CoCreateInstance(VarPtr(Str2Guid(strCLSID_Handler)), 0&, _
            CLSCTX_LOCAL_SERVER, VarPtr(Str2Guid(IID_IPreviewHandler)), _
            m_pIPreviewHandler) = S_OK Then
            
            ' IPreviewHandler initialisieren
            If InitializeHandler(m_pIPreviewHandler, strFileName) = True Then
            
                ' Gre des Previewfenster festlegen
                With tRECT
                    .Left = lngLeft
                    .Top = lngTop
                    .Right = lngLeft + lngWidth
                    .Bottom = lngTop + lngHeight
                End With

                ' Previewfenster (hwnd und Gre) zuweisen
                If Invoke(m_pIPreviewHandler, SetWindow, oPreviewWindow.hWnd, _
                    VarPtr(tRECT)) = S_OK Then
                
                    ' Optional: ein IPreviewHandlerVisuals erstellen
                    If Invoke(m_pIPreviewHandler, QueryInterface, _
                        VarPtr(Str2Guid(IID_IPreviewHandlerVisuals)), _
                        VarPtr(pIPreviewHandlerVisuals)) = S_OK Then
                        
                        If m_bolDebug = True Then Debug.Print "PreviewHandler supports IPreviewHandlerVisuals"
                        
                        ' Backcolor festlegen
                        If Invoke(pIPreviewHandlerVisuals, SetBackgroundColor, _
                            lngBackColor) = S_OK Then
                            
                        End If

                        ' Fontcolor festlegen
                        If Invoke(pIPreviewHandlerVisuals, SetTextColor, _
                            lngTextColor) = S_OK Then
                            
                        End If

                        ' ist ein Pointer auf ein Type LOGFONTW vorhanden
                        If pLOGFONTW <> 0& Then

                            ' LOGFONTW zuweisen
                            If Invoke(pIPreviewHandlerVisuals, SetFont, _
                                pLOGFONTW) = S_OK Then
                            
                            End If

                        End If
                        
                        ' IPreviewHandlerVisuals lschen
                        Call Release(pIPreviewHandlerVisuals)
                        
                    End If
                
                    ' Optional: IPreviewHandlerFrame erstellen
                    If Invoke(m_pIPreviewHandler, QueryInterface, _
                        VarPtr(Str2Guid(IID_IPreviewHandlerFrame)), _
                        VarPtr(pIPreviewHandlerFrame)) = S_OK Then
                        
                        If m_bolDebug = True Then Debug.Print "PreviewHandler supports IPreviewHandlerFrame"
                    
                        ' IPreviewHandlerFrame lschen
                        Call Release(pIPreviewHandlerFrame)
                        
                    End If
                
                    ' Preview anzeigen
                    If Invoke(m_pIPreviewHandler, DoPreview) = S_OK Then

                        bolRet = True
                    
                    End If
                
                End If
            
            End If
            
        End If
        
    ' PreviewHandler fr IThumbnailProvider ermitteln
    ElseIf GetHandlerClsidFromFile(strFileName, IID_IThumbnailProvider, _
        strCLSID_Handler) = True Then
        
        If m_bolDebug = True Then Debug.Print "PreviewHandlerClsid ber IID_IThumbnailProvider und CLSID = " & strCLSID_Handler
        
        ' erstellt ein IThumbnailProvider aus der CLSID des PreviewHandler und IID_IThumbnailProvider
        If CoCreateInstance(VarPtr(Str2Guid(strCLSID_Handler)), 0&, _
            CLSCTX_INPROC_SERVER, VarPtr(Str2Guid(IID_IThumbnailProvider)), _
            pIThumbnailProvider) = S_OK Then
                
            ' IThumbnailProvider initialisieren
            If InitializeHandler(pIThumbnailProvider, strFileName) = True Then
                
                Dim eAlphaType As WTS_ALPHATYPE
                            
                ' Handle auf ein Bitmap in entsprechender Gre ermitteln
                If Invoke(pIThumbnailProvider, GetThumbnail, lngWidth, _
                    VarPtr(hBitmap), VarPtr(eAlphaType)) = S_OK Then
                            
                    ' ist ein Handle auf ein Bitmap vorhanden
                    If hBitmap <> 0& Then
                        
                        ' vom Handle ein Bitmap erstellen
                        Set m_oPicture = CreatePictureFromHandle(hBitmap)
                        
                        ' Bitmap zeichnen
                        Call DrawPicture(m_oPicture, lngBackColor, lngTextColor)

                        bolRet = True
                    
                    End If
                            
                End If
                
            End If
                
            ' IThumbnailProvider lschen
            Call Release(pIThumbnailProvider)
                
        End If
        
    ' PreviewHandler fr IExtractImage ermitteln
    ElseIf GetHandlerClsidFromFile(strFileName, IID_IExtractImage, _
        strCLSID_Handler) = True Then
    
        If m_bolDebug = True Then Debug.Print "PreviewHandlerClsid ber IID_IExtractImage und CLSID = " & strCLSID_Handler

        ' PIDL der Datei / des Ordner ermitteln
        If SHParseDisplayName(StrPtr(strFileName), 0&, pIDL(0), 0&, 0&) = S_OK Then
        
            ' IShellFolder des Desktop ermitteln
            If SHGetDesktopFolder(pIShellFolder) = S_OK Then
            
                ' von der PIDL ein IShellFolder erstellen
                If Invoke(pIShellFolder, BindToObject, pIDL(0), 0&, _
                    VarPtr(Str2Guid(IID_IShellFolder)), _
                    VarPtr(pIShellFolder_Item)) = S_OK Then
                
                    ' ein IExtractImage erstellen
                    If Invoke(pIShellFolder_Item, GetUIObjectOf, 0&, 1&, _
                        VarPtr(pIDL(0)), VarPtr(Str2Guid(IID_IExtractImage)), _
                        0&, VarPtr(pIExtractImage)) = S_OK Then
                            
                        ' Gre der Bitmap festlegen
                        With tSIZE
                            .cx = lngWidth - 50
                            .cy = lngHeight - 50
                        End With
                        
                        strImage = String$(MAX_PATH, 0)
                        ePriority = IEI_PRIORITY_NORMAL
                        eFlags = IEIFLAG_QUALITY
                            
                        ' Pfad zum Bild ermitteln
                        If Invoke(pIExtractImage, GetLocation, StrPtr(strImage), MAX_PATH, _
                            VarPtr(ePriority), VarPtr(tSIZE), 32, VarPtr(eFlags)) = S_OK Then
                                
                            ' ein Handle auf ein Bitmap ermitteln
                            If Invoke(pIExtractImage, Extract, VarPtr(hBitmap)) = S_OK Then
                            
                                ' ist ein Handle auf ein Bitmap vorhanden
                                If hBitmap <> 0& Then
                        
                                    ' vom Handle ein Bitmap erstellen
                                    Set m_oPicture = CreatePictureFromHandle(hBitmap)
                        
                                    ' Bitmap zeichnen
                                    Call DrawPicture(m_oPicture, lngBackColor, lngTextColor)

                                    bolRet = True
                    
                                End If
                            
                            End If
                                
                        End If
                        
                        ' IExtractImage lschen
                        Call Release(pIExtractImage)
                    
                    End If
            
                    ' IShellFolder lschen
                    Call Release(pIShellFolder_Item)
            
                End If
            
                ' IShellFolder lschen
                Call Release(pIShellFolder)
                
            End If
        
            ' PIDL freigeben
            Call CoTaskMemFree(pIDL(0))
        
        End If
        
    End If
    
    ' falls die Methoden ber einen PreviewHandler fehlschlagen
    If bolRet = False Then
    
        ' hier knnte man sich noch berlegen WIC fr Bilder und/oder die Media Foundation
        ' fr Audio/Video einzubinden um eine Vorschau zu bekommen falls die Methoden ber
        ' einen PreviewHandler fehlschlagen.
    
        If m_bolDebug = True Then Debug.Print "alternativer Preview ber IID_IShellItemImageFactory"
        
        ' ein IShellItemImageFactory von der Datei / des Ordner erstellen
        If SHCreateItemFromParsingName(StrPtr(strFileName), 0&, _
            VarPtr(Str2Guid(IID_IShellItemImageFactory)), _
            pIShellItemImageFactory) = S_OK Then

            lngThumbSize = lngHeight - 50

            ' maximale Gre
            If lngThumbSize > 1024 Then lngThumbSize = 1204
            
            ' ein Handle auf ein Bitmap ermitteln
            If Invoke(pIShellItemImageFactory, GetImage, _
                lngThumbSize, lngThumbSize, _
                SIIGBF.SIIGBF_RESIZETOFIT, VarPtr(hBitmap)) = S_OK Then

                ' ist ein Handle auf ein Bitmap vorhanden
                If hBitmap <> 0& Then
                        
                    ' vom Handle ein Bitmap erstellen
                    Set m_oPicture = CreatePictureFromHandle(hBitmap)
                        
                    ' Bitmap zeichnen
                    Call DrawPicture(m_oPicture, lngBackColor, lngTextColor)
                    
                    bolRet = True
                    
                End If

            End If

            ' IShellItemImageFactory lschen
            Call Release(pIShellItemImageFactory)

        End If
    
    End If

    ShowPreviewForFile = bolRet
    
End Function

' ----==== Gre und Position der Vorschau ndern ====----
Public Function MovePreviewWindow(ByVal lngLeft As Long, _
    ByVal lngTop As Long, ByVal lngWidth As Long, _
    ByVal lngHeight As Long) As Boolean

    Dim bolRet As Boolean
    Dim tRECT As RECT
    
    bolRet = False

    ' ist ein IPreviewHandler vorhanden
    If m_pIPreviewHandler <> 0& Then
    
        ' neue Gre speichern
        With tRECT
            .Left = lngLeft
            .Top = lngTop
            .Right = lngLeft + lngWidth
            .Bottom = lngTop + lngHeight
        End With

        ' neue Gre fr den IPreviewHandler festlegen
        If Invoke(m_pIPreviewHandler, SetRect, VarPtr(tRECT)) = S_OK Then
        
            bolRet = True
            
        End If
        
    Else
    
        ' ist eine gespeicherte PictureBox vorhanden
        If Not m_oPreviewWindow Is Nothing Then
        
            ' altes Bild lschen
            m_oPreviewWindow.Picture = Nothing
            
        End If
    
        ' ist ein altes Bild gespeichert
        If Not m_oPicture Is Nothing Then
        
            ' neues Bild in neuer Gre erstellen
            bolRet = ShowPreviewForFile(m_strFileName, _
                m_oPreviewWindow, lngLeft, lngTop, lngWidth, _
                lngHeight, m_lngBackColor, m_lngTextColor, _
                m_pLOGFONTW, m_bolDebug)
    
        End If
    
    End If

    MovePreviewWindow = bolRet
    
End Function

' ----==== Setzt den Focus auf den Parent, auf der die Vorschau angezeigt wird ====----
Public Function SetPreviewWindowParentFocus() As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    ' ist ein IPreviewHandler vorhanden
    If m_pIPreviewHandler <> 0& Then
    
        ' Focus auf den Parent setzen
        If Invoke(m_pIPreviewHandler, SetFocus) = S_OK Then
        
            bolRet = True
            
        End If
        
    Else
    
        ' ist eine gespeicherte PictureBox vorhanden
        If Not m_oPreviewWindow Is Nothing Then
        
            ' Focus auf die PictureBox
            m_oPreviewWindow.SetFocus
            
        End If
    
    End If

    SetPreviewWindowParentFocus = bolRet

End Function

' ----==== Gibt den hWnd des Parent zurck, auf der die Vorschau angezeigt wird ====----
Public Function GetPreviewWindowParentHwnd() As Long

    Dim lngRet As Long
    Dim lngHwmd As Long
    
    ' ist ein IPreviewHandler vorhanden
    If m_pIPreviewHandler <> 0& Then
    
        ' hWnd des Parent ermitteln
        If Invoke(m_pIPreviewHandler, QueryFocus, VarPtr(lngHwmd)) = S_OK Then
        
            lngRet = lngHwmd
            
        End If
        
    Else
    
        ' ist eine gespeicherte PictureBox vorhanden
        If Not m_oPreviewWindow Is Nothing Then
        
            ' hWnd der PictureBox
            lngRet = m_oPreviewWindow.hWnd
            
        End If
    
    End If

    GetPreviewWindowParentHwnd = lngRet

End Function

' ----==== alles lschen und freigeben ====----
Private Sub UnloadAndRelease()

    ' ist ein IPreviewHandler vorhanden
    If m_pIPreviewHandler <> 0& Then
    
        ' verwendete Ressourcen des IPreviewHandler lschen
        If Invoke(m_pIPreviewHandler, Unload) = S_OK Then

            ' IPreviewHandler lschen
            Call Release(m_pIPreviewHandler)
            
        End If
        
    Else
    
        ' ist ein gespeichertes Bild vorhanden
        If Not m_oPicture Is Nothing Then
            
            ' Bild lschen
            Set m_oPicture = Nothing
        
        End If
        
        ' ist eine gespeicherte PictureBox vorhanden
        If Not m_oPreviewWindow Is Nothing Then
            
            ' altes Bild in der PictureBox lschen
            m_oPreviewWindow.Picture = Nothing

            ' gespeicherte PicturBox lschen
            Set m_oPreviewWindow = Nothing
        
        End If
    
    End If

    ' gespeichertes zurck setzen
    m_strFileName = vbNullString
    m_lngBackColor = vbWhite
    m_lngTextColor = vbBlack
    m_pLOGFONTW = 0&
    m_bolDebug = False
    
End Sub

' ----==== zeichnet ein Picture auf die gespeicherte PictureBox  ====----
Private Sub DrawPicture(ByVal oPicture As StdPicture, _
    ByVal lngBackColor As Long, _
    ByVal lngTextColor As Long)
    
    Dim hBrush As Long
    Dim hOldBrush As Long
    Dim lngPicX As Long
    Dim lngPicY As Long
    Dim lngPicWidth As Long
    Dim lngPicHeight As Long
    
    ' ist eine gespeicherte PictureBox vorhanden
    If Not m_oPreviewWindow Is Nothing Then
        
        ' altes Bild in der PictureBox lschen
        m_oPreviewWindow.Picture = Nothing
        
        ' neue Einstellungen setzen
        m_oPreviewWindow.ScaleMode = vbPixels
        m_oPreviewWindow.AutoRedraw = True
        m_oPreviewWindow.BackColor = lngBackColor
        m_oPreviewWindow.ForeColor = lngTextColor
    
        ' Gre des Picture ermitteln
        lngPicWidth = CLng(m_oPreviewWindow.ScaleX(m_oPicture.Width, vbHimetric, vbPixels))
        lngPicHeight = CLng(m_oPreviewWindow.ScaleY(m_oPicture.Height, vbHimetric, vbPixels))
    
        ' Position an der gezeichnet werden soll (zentriert)
        lngPicX = CLng((m_oPreviewWindow.Width / 2)) - CLng(lngPicWidth / 2)
        lngPicY = CLng((m_oPreviewWindow.Height / 2)) - CLng(lngPicHeight / 2)

        ' Picture zentriert in die PictureBox zeichnen
        Call m_oPreviewWindow.PaintPicture(m_oPicture, lngPicX, lngPicY)
            
        ' einen weien Brush erstellen
        hBrush = CreateSolidBrush(lngBackColor)
        
        With m_oPreviewWindow
            
            ' Brush in den DC
            hOldBrush = SelectObject(.hdc, hBrush)
            
            ' Ecke links oben
            Call ExtFloodFill(.hdc, lngPicX + 1, lngPicY + 1, vbBlack, FLOODFILLSURFACE)
            
            ' Ecke rechts oben
            Call ExtFloodFill(.hdc, lngPicX + lngPicWidth - 1, lngPicY + 1, vbBlack, FLOODFILLSURFACE)
            
            ' Ecke links unten
            Call ExtFloodFill(.hdc, lngPicX + 1, (lngPicY + lngPicHeight) - 3, vbBlack, FLOODFILLSURFACE)
            
            ' Ecke rechts unten
            Call ExtFloodFill(.hdc, (lngPicX + lngPicWidth) - 3, (lngPicY + lngPicHeight) - 3, vbBlack, FLOODFILLSURFACE)
            
            ' alten Brush in den DC
            hBrush = SelectObject(.hdc, hOldBrush)
            
            ' brush lschen
            Call DeleteObject(hBrush)
            
        End With
        
    End If

End Sub

' ----==== vom Handle auf ein Bitmap ein Bitmap erstellen  ====----
Private Function CreatePictureFromHandle(ByVal hBitmap As Long) As StdPicture

    Dim tPICTDESC As PICTDESC
    Dim oPicture As IPicture

    ' Paramter festlegen
    With tPICTDESC
        .cbSizeOfStruct = Len(tPICTDESC)
        .picType = vbPicTypeBitmap
        .hgdiObj = hBitmap
        .hPalOrXYExt = 0&
    End With

    ' Bitmap vom Handle erstellen
    If OleCreatePictureIndirect(tPICTDESC, Str2Guid(IID_IPicture), _
        API_TRUE, oPicture) = S_OK Then
    
        Set CreatePictureFromHandle = oPicture
        
        Set oPicture = Nothing
        
    Else
    
        Set CreatePictureFromHandle = Nothing
        
    End If

End Function

' ----==== PreviewHandler initialisieren ====----
Private Function InitializeHandler(ByVal pHandler As Long, _
    ByVal strFileName As String) As Boolean
    
    Dim bolRet As Boolean
    Dim pIStream As Long
    Dim pIShellItem As Long
    Dim pIInitializeWithXXX As Long
    
    bolRet = False
    
    ' kann der PreviewHandler per IInitializeWithFile initialisiert werden
    If Invoke(pHandler, QueryInterface, _
        VarPtr(Str2Guid(IID_IInitializeWithFile)), _
        VarPtr(pIInitializeWithXXX)) = S_OK Then
        
        If m_bolDebug = True Then Debug.Print "InitializeWithFile"
        
        ' per Datei initialisieren
        If Invoke(pIInitializeWithXXX, Initialize, _
            StrPtr(strFileName), STGM.STGM_READ) = S_OK Then
            
            bolRet = True
            
        End If
        
        ' IInitializeWithFile lschen
        Call Release(pIInitializeWithXXX)
        
    ' kann der PreviewHandler per IInitializeWithStream initialisiert werden
    ElseIf Invoke(pHandler, QueryInterface, _
        VarPtr(Str2Guid(IID_IInitializeWithStream)), _
        VarPtr(pIInitializeWithXXX)) = S_OK Then
        
        If m_bolDebug = True Then Debug.Print "InitializeWithStream"
        
        ' ein IStream auf die Datei erstellen
        If SHCreateStreamOnFileEx(StrPtr(strFileName), _
            STGM.STGM_READ Or STGM.STGM_SHARE_DENY_NONE, _
            0&, 0&, 0&, pIStream) = S_OK Then
            
            ' per IStream initialisieren
            If Invoke(pIInitializeWithXXX, Initialize, _
                pIStream, STGM.STGM_READ) = S_OK Then
                
                bolRet = True
                
            End If
            
            ' IStream lschen
            Call Release(pIStream)
            
        End If
        
        ' IInitializeWithStream lschen
        Call Release(pIInitializeWithXXX)

    ' kann der PreviewHandler per IInitializeWithItem initialisiert werden
    ElseIf Invoke(pHandler, QueryInterface, _
        VarPtr(Str2Guid(IID_IInitializeWithItem)), _
        VarPtr(pIInitializeWithXXX)) = S_OK Then

        If m_bolDebug = True Then Debug.Print "InitializeWithItem"

        ' ein IShellItem von der Datei erstellen
        If SHCreateItemFromParsingName(StrPtr(strFileName), 0&, _
            VarPtr(Str2Guid(IID_IShellItem)), pIShellItem) = S_OK Then

            ' per IShellItem initialisieren
            If Invoke(pIInitializeWithXXX, Initialize, _
                pIShellItem, STGM.STGM_READ) = S_OK Then

                bolRet = True

            End If

            ' IShellItem lschen
            Call Release(pIShellItem)

        End If
        
        ' IInitializeWithItem lschen
        Call Release(pIInitializeWithXXX)
        
    End If
    
    InitializeHandler = bolRet
    
End Function

' ----==== CLSID fr den PreviewHandler ermitteln ====----
Private Function GetHandlerClsidFromFile(ByVal strFileName As String, _
    ByVal strHandlerIID As String, ByRef strHandlerClsid As String) As Boolean

    Dim bolRet As Boolean
    Dim strClsid As String
    Dim strFileExt As String

    bolRet = False
    
    ' Dateierweiterung der Datei auslesen
    strFileExt = Mid$(strFileName, InStrRev(strFileName, ".") + 1)
    
    ' CLSID fr den PreviewHandler fr die Dateierweiterung ermitteln
    strClsid = GetHandlerClsidFromFileExt("." & strFileExt, strHandlerIID)
    
    ' wenn es keine CLSID per Dateierweiterung gibt
    If Len(strClsid) = 0& Then
    
        ' schauen ob es einen andere CLSID gibt
        strClsid = GetHandlerClsidFromFileExt(strFileExt & "file", strHandlerIID)
    
    End If
    
    ' es gibt eine CLSID
    If Len(strClsid) = 38& Then
    
        strHandlerClsid = strClsid
        
        bolRet = True
    
    Else
    
        strHandlerClsid = vbNullString
        
    End If
    
    GetHandlerClsidFromFile = bolRet
    
End Function

' ----==== CLSID per Dateierweiterung ermitteln ====----
Private Function GetHandlerClsidFromFileExt(ByVal strFileExt As String, _
    ByVal strHandlerIID As String) As String

    Dim lngOut As Long
    Dim strRet As String
    Dim strClsid As String
    
    lngOut = 64
    strClsid = String$(lngOut, 0)
    
    ' CLSID passend zur HandlerIID ermitteln
    If AssocQueryStringW(ASSOCF_NONE, ASSOCSTR_SHELLEXTENSION, _
        StrPtr(strFileExt), StrPtr(strHandlerIID), _
        StrPtr(strClsid), lngOut) = S_OK Then
        
        ' ist eine CLSID vorhanden
        If lngOut > 0& Then
        
            ' CLSID aus dem Puffer
            strRet = Left$(strClsid, lngOut - 1)
            
        End If
        
    End If
    
    GetHandlerClsidFromFileExt = strRet
    
End Function

' ----==== fhrt die Funktion OleInvoke aus ====----
Private Function Invoke(ByVal pInterface As Long, _
    ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

' ----==== fhrt eine Funktionen eines Interface aus ====----
Private Function OleInvoke(ByVal pInterface As Long, _
    ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lRet As Long
    Dim lItem As Long
    Dim lCount As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' wenn ein Pointer auf ein Interface vorhanden ist
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            vParam = aParam

            ' ist der Variant ein Array
            If IsArray(vParam) Then vParam = vParam(0)

            ' Anzahl der Parameter
            lCount = UBound(vParam)

            ' alle Parameter durchlaufen
            For lItem = 0 To lCount

                ' Typ des Parameter
                oleTyp(lItem) = VarType(vParam(lItem))

                ' Pointer auf den Parameter
                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If
        
        ' Funktion des Interfaces aufrufen
        lRet = DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), vRet)
        
        If lRet <> S_OK Then
            
            If m_bolDebug = True Then Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If
        
        If vRet <> S_OK Then
        
            If m_bolDebug = True Then Debug.Print "COM-Error: 0x" & Hex$(vRet)
        
        End If

    End If

    OleInvoke = vRet

End Function

' ----==== fhrt die Funktion Release eines Interfaces aus ====----
Private Sub Release(ByRef pInterface As Long)

    Dim vRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== GUID-String -> GUID ====----
Private Function Str2Guid(ByVal strGUID As String) As GUID

    Call CLSIDFromString(StrPtr(strGUID), Str2Guid)
    
End Function

